## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 10;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# Unset -s on python shebang - ensure that extensions installed with pip
# to user locations are seen and properly loaded
%undefine _py3_shebang_s

Name:           python-jupyter-client
Version:        8.6.1
Release:        %autorelease
Summary:        Jupyter protocol implementation and client libraries

# Automatically converted from old format: BSD - review is highly recommended.
License:        LicenseRef-Callaway-BSD
URL:            https://jupyter.org
Source0:        %{pypi_source jupyter_client}

# Avoid a DeprecationWarning on Python 3.13+
Patch:          https://github.com/jupyter/jupyter_client/pull/1027.patch

BuildArch:      noarch

BuildRequires:  python3-devel

# Dropped -doc subpackage beginning with Fedora 42
%bcond doc %{defined fc41}
%bcond tests 1

%if %{with tests}
# Optional test dependency, look for test_datetimes_msgpack
BuildRequires:  python3dist(msgpack)
# For test_load_ips
BuildRequires:  /usr/sbin/ip
BuildRequires:  /usr/sbin/ifconfig
%endif

%description
This package contains the reference implementation of the Jupyter protocol.
It also provides client and kernel management APIs for working with kernels.

It also provides the `jupyter kernelspec` entrypoint for installing kernelspecs
for use with Jupyter frontends.

%package -n     python3-jupyter-client
Summary:        %{summary}

# It fallbacks to ifconfig without this, and ifconfig is deprecated
Recommends:     python3-netifaces

%if %{undefined fc41}
# Dropped -doc subpackage beginning with Fedora 42
Obsoletes:      python-jupyter-client-doc < 8.6.1-10
%endif

%description -n python3-jupyter-client
This package contains the reference implementation of the Jupyter protocol.
It also provides client and kernel management APIs for working with kernels.

It also provides the `jupyter kernelspec` entrypoint for installing kernelspecs
for use with Jupyter frontends.

%if %{with doc}
%package -n python-jupyter-client-doc
Summary:        Documentation of the Jupyter protocol reference implementation

%description -n python-jupyter-client-doc
Documentation of the reference implementation of the Jupyter protocol
%endif

%prep
%autosetup -p1 -n jupyter_client-%{version}
# Drop dependencies on coverage, linters etc.
sed -Ei '/"\b(codecov|coverage|mypy|pre-commit|pytest-cov)\b",/d' pyproject.toml


%if %{with doc}
# Use local objects.inv for intersphinx:
sed -i "s|\(('http://ipython.readthedocs.io/en/stable/', \)None)|\1'/usr/share/doc/python3-ipython-doc/html/objects.inv')|" docs/conf.py
%endif


%generate_buildrequires
%pyproject_buildrequires %{?with_tests:-x test} %{?with_doc:-x docs}


%build
%pyproject_wheel

%if %{with doc}
PYTHONPATH=build/lib/ sphinx-build-3 docs html
# remove the sphinx-build leftovers
rm -r html/.{doctrees,buildinfo}
%endif


%install
%pyproject_install
%pyproject_save_files jupyter_client


%if %{with tests}
%check
# The two tests testing signals for kernels are flaky because
# if it takes the kernel more than one second to respond, it's killed.
# The tests work fine outside mock.
# test_open_tunnel needs ssh and internet connections.
%pytest -Wdefault -v -k "not test_signal_kernel_subprocesses and not test_async_signal_kernel_subprocesses and not test_open_tunnel"
%endif


%global _docdir_fmt %{name}

%files -n python3-jupyter-client -f %{pyproject_files}
%doc README.md
%{_bindir}/jupyter-kernel
%{_bindir}/jupyter-kernelspec
%{_bindir}/jupyter-run

%if %{with doc}
%files -n python-jupyter-client-doc
%doc html
%endif

%changelog
## START: Generated by rpmautospec
* Tue Nov 26 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 8.6.1-10
- Drop -doc subpackage beginning with Fedora 42

* Tue Nov 26 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 8.6.1-9
- Drop the BuildRequires on python3-zmq-tests

* Tue Sep 24 2024 Karolina Surma <ksurma@redhat.com> - 8.6.1-8
- Don't build wheel when generating buildrequires

* Wed Sep 04 2024 Miroslav Suchý <msuchy@redhat.com> - 8.6.1-7
- convert license to SPDX

* Fri Jul 19 2024 Fedora Release Engineering <releng@fedoraproject.org> - 8.6.1-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Mon Jun 10 2024 Miro Hrončok <miro@hroncok.cz> - 8.6.1-5
- Avoid a DeprecationWarning on Python 3.13+

* Sun Jun 09 2024 Python Maint <python-maint@redhat.com> - 8.6.1-4
- Rebuilt for Python 3.13

* Sun Jun 09 2024 Python Maint <python-maint@redhat.com> - 8.6.1-3
- Bootstrap for Python 3.13

* Mon Mar 11 2024 Lumír Balhar <lbalhar@redhat.com> - 8.6.1-1
- Update to 8.6.1 (rhbz#2149176)

* Fri Jan 26 2024 Fedora Release Engineering <releng@fedoraproject.org> - 7.4.9-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Mon Jan 22 2024 Fedora Release Engineering <releng@fedoraproject.org> - 7.4.9-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Fri Jul 21 2023 Fedora Release Engineering <releng@fedoraproject.org> - 7.4.9-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Sun Jul 02 2023 Python Maint <python-maint@redhat.com> - 7.4.9-4
- Rebuilt for Python 3.12

* Thu Jun 29 2023 Python Maint <python-maint@redhat.com> - 7.4.9-3
- Bootstrap for Python 3.12

* Fri Jan 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 7.4.9-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Mon Jan 16 2023 Miro Hrončok <mhroncok@redhat.com> - 7.4.9-1
- Update to 7.4.9

* Mon Nov 28 2022 Lumír Balhar <lbalhar@redhat.com> - 7.4.7-1
- Update to 7.4.7 (rhbz#2133949)

* Thu Oct 13 2022 Karolina Surma <ksurma@redhat.com> - 7.4.2-1
- Update to 7.4.2

* Thu Sep 01 2022 Charalampos Stratakis <cstratak@redhat.com> - 7.3.5-2
- Enable tests again

* Tue Aug 02 2022 Charalampos Stratakis <cstratak@redhat.com> - 7.3.5-1
- Update to 7.3.5
- Disable tests
- Fixes: rhbz#2121503

* Fri Jul 22 2022 Fedora Release Engineering <releng@fedoraproject.org> - 7.1.2-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Wed Jun 15 2022 Python Maint <python-maint@redhat.com> - 7.1.2-4
- Rebuilt for Python 3.11

* Tue Jun 14 2022 Python Maint <python-maint@redhat.com> - 7.1.2-3
- Bootstrap for Python 3.11

* Mon Mar 28 2022 Miro Hrončok <mhroncok@redhat.com> - 7.1.2-2
- Drop build-time dependencies on coverage, linters etc.

* Tue Jan 25 2022 Miro Hrončok <mhroncok@redhat.com> - 7.1.2-1
- Update to 7.1.2
- Fixes: rhbz#2040876

* Fri Jan 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 7.1.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Mon Nov 29 2021 Karolina Surma <ksurma@redhat.com> - 7.1.0-2
- Remove -s from Python shebang in `jupyter-kernel`, `jupyter-kernelspec`
  and `jupyter-run` to let Jupyter see pip installed extensions

* Thu Nov 25 2021 Karolina Surma <ksurma@redhat.com> - 7.1.0-1
- Update to 7.1.0
Resolves: rhbz#2025674

* Tue Oct 26 2021 Lumír Balhar <lbalhar@redhat.com> - 7.0.6-1
- Update to 7.0.6
Resolves: rhbz#2008516

* Mon Aug 30 2021 Lumír Balhar <lbalhar@redhat.com> - 7.0.3-1
- Update to 7.0.3
Resolves: rhbz#1948434

* Fri Jul 23 2021 Fedora Release Engineering <releng@fedoraproject.org> - 6.1.12-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Fri Jun 04 2021 Python Maint <python-maint@redhat.com> - 6.1.12-4
- Rebuilt for Python 3.10

* Fri Jun 04 2021 Python Maint <python-maint@redhat.com> - 6.1.12-3
- Bootstrap for Python 3.10

* Fri Apr 09 2021 Karolina Surma <ksurma@redhat.com> - 6.1.12-1
- Update to 6.1.12
Resolves: rhbz#1938505

* Fri Mar 05 2021 Miro Hrončok <mhroncok@redhat.com> - 6.1.11-2
- Unpin jedi to make the package installable again with jedi 0.18

* Fri Jan 29 8:25:17 CET 2021 Tomas Hrnciar <thrnciar@redhat.com> - 6.1.11-1
- Update to 6.1.11 (#1914202)

* Wed Jan 27 2021 Fedora Release Engineering <releng@fedoraproject.org> - 6.1.7-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Thu Sep 17 2020 Tomas Hrnciar <thrnciar@redhat.com> - 6.1.7-1
- Update to 6.1.7 (#1856627)

* Wed Jul 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 6.1.5-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Thu Jun 25 2020 Lumír Balhar <lbalhar@redhat.com> - 6.1.5-1
- Update to 6.1.5 (#1852265)

* Sun May 24 2020 Miro Hrončok <mhroncok@redhat.com> - 5.3.4-4
- Rebuilt for Python 3.9

* Sun May 24 2020 Miro Hrončok <mhroncok@redhat.com> - 5.3.4-3
- Bootstrap for Python 3.9

* Thu Jan 30 2020 Fedora Release Engineering <releng@fedoraproject.org> - 5.3.4-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Tue Nov 12 2019 Miro Hrončok <mhroncok@redhat.com> - 5.3.4-1
- Update to 5.3.4 (#1759726)
- Run tests

* Thu Sep 26 2019 Jerry James <loganjerry@gmail.com> - 5.3.3-1
- Update to 5.3.3 (bz 1727659, also fixes bz 1755635)
- Drop old workaround for dual python2/python3 builds
- Use local objects.inv for intersphinx, BR python3-ipython-doc

* Sun Aug 18 2019 Miro Hrončok <mhroncok@redhat.com> - 5.2.3-10
- Rebuilt for Python 3.8

* Sun Aug 18 2019 Miro Hrončok <mhroncok@redhat.com> - 5.2.3-9
- Bootstrap for Python 3.8

* Fri Jul 26 2019 Fedora Release Engineering <releng@fedoraproject.org> - 5.2.3-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Thu Feb 14 2019 Miro Hrončok <mhroncok@redhat.com> - 5.2.3-7
- Subpackage python2-jupyter-client has been removed
  See https://fedoraproject.org/wiki/Changes/Mass_Python_2_Package_Removal

* Sat Feb 02 2019 Fedora Release Engineering <releng@fedoraproject.org> - 5.2.3-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Sat Jul 14 2018 Fedora Release Engineering <releng@fedoraproject.org> - 5.2.3-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Wed Jun 20 2018 Miro Hrončok <mhroncok@redhat.com> - 5.2.3-4
- Rebuilt for Python 3.7

* Tue Jun 19 2018 Miro Hrončok <mhroncok@redhat.com> - 5.2.3-3
- Bootstrap for Python 3.7

* Wed Mar 14 2018 Miro Hrončok <mhroncok@redhat.com> - 5.2.3-1
- Updated to 5.2.3 (#1538378)
- Do not have 3.6 bytecode in 2.7 package

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 5.2.1-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Tue Jan 30 2018 Miro Hrončok <mhroncok@redhat.com> - 5.2.1-3
- Enable automatic dependency generator, drop manual Python requires
- Fixes missing dependency on dateutil
- Add missing BRs for docs

* Sun Jan 14 2018 Miro Hrončok <mhroncok@redhat.com> - 5.2.1-2
- Recommend netifaces (#1534203)

* Thu Jan 04 2018 Miro Hrončok <mhroncok@redhat.com> - 5.2.1-1
- Updated to 5.2.1 (#1425248)
- Use Python 3 to build the docs, add BR on python3-sphinxcontrib-github-alt

* Fri Sep 01 2017 Miro Hrončok <mhroncok@redhat.com> - 4.4.0-5
- Remove -2, -3, etc. executables (#1410332)

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 4.4.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 4.4.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Mon Dec 19 2016 Miro Hrončok <mhroncok@redhat.com> - 4.4.0-2
- Rebuild for Python 3.6

* Mon Sep 26 2016 Thomas Spura <tomspur@fedoraproject.org> - 4.4.0-1
- update to 4.4.0
- Source0: use files.pythonhosted.org

* Mon Apr 25 2016 Thomas Spura <tomspur@fedoraproject.org> - 4.2.2-4
- Use simpler docdir_fmt
- Fix BR/R requires

* Tue Apr 19 2016 Thomas Spura <tomspur@fedoraproject.org> - 4.2.2-3
- Fix docs generation (Zbigniew, #1327989)
- Require python2- instead python- where possible

* Mon Apr 18 2016 Thomas Spura <tomspur@fedoraproject.org> - 4.2.2-2
- Use dash in name
- Adjust description
- Use %%license

* Mon Apr 18 2016 Thomas Spura <tomspur@fedoraproject.org> - 4.2.2-1
- Initial package.

## END: Generated by rpmautospec
